package com.landray.kmss.sys.attachment.integrate.wps.util;

import com.landray.kmss.sys.appconfig.model.BaseAppconfigCache;
import com.landray.kmss.sys.filestore.scheduler.third.wps.WpsUtil;
import java.util.Map;
import net.sf.json.JSONObject;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.integrate.wps.interfaces.ISysAttachmentWpsCloudOfficeProvider;
import com.landray.kmss.sys.attachment.integrate.wps.interfaces.ISysAttachmentWpsWebOfficeProvider;
import java.util.Iterator;
import java.util.List;
import com.landray.kmss.sys.attachment.util.SysAttConfigUtil;
import com.landray.kmss.util.StringUtil;
import com.landray.kmss.sys.attachment.integrate.wps.SysAttWpsWebOfficePlugin;

public class SysAttWpsCloudUtil
{
    public static Boolean isEnable() throws Exception {
        Boolean flag = false;
        final List<SysAttWpsWebOfficePlugin> plugins = SysAttWpsWebOfficePluginUtil.getExtensionList();
        if (plugins != null && plugins.size() > 0) {
            for (final SysAttWpsWebOfficePlugin plugin : plugins) {
                if (plugin == null) {
                    continue;
                }
                final String fdKey = plugin.getKey();
                if (!StringUtil.isNotNull(fdKey) || !"wpsCloudOffice".equals(fdKey)) {
                    continue;
                }
                final ISysAttachmentWpsWebOfficeProvider provider = plugin.getProvider();
                flag = provider.isEnabled();
            }
        }
        if (flag && "1".equals(SysAttConfigUtil.getOnlineToolType())) {
            return true;
        }
        return false;
    }
    
    public static Boolean isEnableWpsWebOffice() throws Exception {
        return "3".equals(SysAttConfigUtil.getOnlineToolType());
    }
    
    public static Boolean isEnable(final boolean isMobile) throws Exception {
        Boolean flag = false;
        final List<SysAttWpsWebOfficePlugin> plugins = SysAttWpsWebOfficePluginUtil.getExtensionList();
        if (plugins != null && plugins.size() > 0) {
            for (final SysAttWpsWebOfficePlugin plugin : plugins) {
                final String fdKey = plugin.getKey();
                if (StringUtil.isNotNull(fdKey) && "wpsCloudOffice".equals(fdKey)) {
                    final ISysAttachmentWpsWebOfficeProvider provider = plugin.getProvider();
                    flag = provider.isEnabled();
                }
            }
        }
        Boolean wpsCloud = false;
        if (isMobile && "0".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadJGForMobile())) {
            wpsCloud = true;
        }
        else if (isMobile && "3".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadWPSForMobile())) {
            wpsCloud = true;
        }
        else if (isMobile && "4".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadWPSForMobile())) {
            wpsCloud = true;
        }
        else if (isMobile && "1".equals(SysAttConfigUtil.getOnlineToolType()) && "2".equals(SysAttConfigUtil.isReadWPSCloudForMobile())) {
            wpsCloud = true;
        }
        if (flag && wpsCloud) {
            return true;
        }
        return false;
    }
    
    public static Boolean isEnableMobile(final boolean isMobile) throws Exception {
        Boolean wpsCloud = false;
        if (isMobile && "0".equals(SysAttConfigUtil.getOnlineToolType()) && "1".equals(SysAttConfigUtil.isReadJGForMobile())) {
            wpsCloud = true;
        }
        else if (isMobile && "3".equals(SysAttConfigUtil.getOnlineToolType()) && "1".equals(SysAttConfigUtil.isReadWPSForMobile())) {
            wpsCloud = true;
        }
        else if (isMobile && "4".equals(SysAttConfigUtil.getOnlineToolType()) && "1".equals(SysAttConfigUtil.isReadWPSCenterForMobile())) {
            wpsCloud = true;
        }
        else if (isMobile && "1".equals(SysAttConfigUtil.getOnlineToolType()) && "1".equals(SysAttConfigUtil.isReadWPSCloudForMobile())) {
            wpsCloud = true;
        }
        return wpsCloud;
    }
    
    public static Boolean isKKMobileEnabel() throws Exception {
        Boolean kkMobile = false;
        if ("0".equals(SysAttConfigUtil.getOnlineToolType()) && "0".equals(SysAttConfigUtil.isReadJGForMobile())) {
            kkMobile = true;
        }
        return kkMobile;
    }
    
    public static String getUrl() throws Exception {
        final List<SysAttWpsWebOfficePlugin> plugins = SysAttWpsWebOfficePluginUtil.getExtensionList();
        if (plugins != null && plugins.size() > 0) {
            for (final SysAttWpsWebOfficePlugin plugin : plugins) {
                final String fdKey = plugin.getKey();
                if (StringUtil.isNotNull(fdKey) && "wpsCloudOffice".equals(fdKey)) {
                    final ISysAttachmentWpsWebOfficeProvider provider = plugin.getProvider();
                    if (StringUtil.isNotNull(provider.getUrl())) {
                        String Url = provider.getUrl();
                        if (Url.endsWith("/")) {
                            Url = Url.substring(0, Url.length() - 1);
                        }
                        return Url;
                    }
                    continue;
                }
            }
        }
        return null;
    }
    
    public static String getAppid() throws Exception {
        final List<SysAttWpsWebOfficePlugin> plugins = SysAttWpsWebOfficePluginUtil.getExtensionList();
        if (plugins != null && plugins.size() > 0) {
            for (final SysAttWpsWebOfficePlugin plugin : plugins) {
                final String fdKey = plugin.getKey();
                if (StringUtil.isNotNull(fdKey) && "wpsCloudOffice".equals(fdKey)) {
                    final ISysAttachmentWpsWebOfficeProvider provider = plugin.getProvider();
                    return provider.getAppid();
                }
            }
        }
        return null;
    }
    
    public static String getAppkey() throws Exception {
        final List<SysAttWpsWebOfficePlugin> plugins = SysAttWpsWebOfficePluginUtil.getExtensionList();
        if (plugins != null && plugins.size() > 0) {
            for (final SysAttWpsWebOfficePlugin plugin : plugins) {
                final String fdKey = plugin.getKey();
                if (StringUtil.isNotNull(fdKey) && "wpsCloudOffice".equals(fdKey)) {
                    final ISysAttachmentWpsWebOfficeProvider provider = plugin.getProvider();
                    return provider.getAppkey();
                }
            }
        }
        return null;
    }
    
    public static Boolean isAttHadSyncByAttMainId(final String fdFileId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.isAttHadSyncByAttMainId(fdFileId);
        }
        return false;
    }
    
    public static void syncAttToAddByMainId(final String fdAttMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            wpsCloudOfficeProvider.syncAttToAddByMainId(fdAttMainId);
        }
    }
    
    public static void syncAttToUpdateByMainId(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            wpsCloudOfficeProvider.syncAttToUpdateByMainId(fdMainId);
        }
    }
    
    public static void updateAttByMainId(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            wpsCloudOfficeProvider.updateAttByMainId(fdMainId);
        }
    }
    
    public static JSONObject getWpsCloudViewUrl(final String fdAttMainId, final boolean canEdit, final String history) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsCloudViewUrl(fdAttMainId, canEdit, history);
        }
        return null;
    }
    
    public static JSONObject getWpsCloudViewUrl(final String fdAttMainId, final boolean canEdit, final String history, final boolean contentFlag) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsCloudViewUrl(fdAttMainId, canEdit, history, contentFlag);
        }
        return null;
    }
    
    public static JSONObject getWpsCloudViewParam(final String fdAttMainId, final String mode) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsCloudViewParam(fdAttMainId, mode);
        }
        return null;
    }
    
    public static String getResult(final String taskID) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getResult(taskID);
        }
        return null;
    }
    
    public static String opRevisions(final String downurl, final String fileId, final String ext) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.opRevisions(downurl, fileId, ext);
        }
        return null;
    }
    
    public static String opRevisions(final String downurl, final String fileId, final String ext, final String fdModelId, final String fdModelName) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.opRevisions(downurl, fileId, ext, fdModelId, fdModelName);
        }
        return null;
    }
    
    public static String opRevisions(final String downurl, final String fileId, final String ext, final String fdModelId, final String fdModelName, final String fdAttMainId, final String type) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.opRevisions(downurl, fileId, ext, fdModelId, fdModelName, fdAttMainId, type);
        }
        return null;
    }
    
    public static String opRevisions(final String downurl, final String fileId, final String ext, final String fdModelId, final String fdModelName, final String fdAttMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.opRevisions(downurl, fileId, ext, fdModelId, fdModelName, fdAttMainId, "1");
        }
        return null;
    }
    
    public static String setRed(final List<Map<String, Object>> fileInfos, final List<Map<String, Object>> fillDatas) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.setRed((List)fileInfos, (List)fillDatas);
        }
        return null;
    }
    
    public static String setRed(final List<Map<String, Object>> fileInfos, final List<Map<String, Object>> fillDatas, final String fdModelId, final String fdModelName) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.setRed((List)fileInfos, (List)fillDatas, fdModelId, fdModelName);
        }
        return null;
    }
    
    public static String setRed(final List<Map<String, Object>> fileInfos, final List<Map<String, Object>> fillDatas, final String fdModelId, final String fdModelName, final String fdAttMainId, final String type) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.setRed((List)fileInfos, (List)fillDatas, fdModelId, fdModelName, fdAttMainId, type);
        }
        return null;
    }
    
    public static String setRed(final List<Map<String, Object>> fileInfos, final List<Map<String, Object>> fillDatas, final String fdModelId, final String fdModelName, final String fdAttMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.setRed((List)fileInfos, (List)fillDatas, fdModelId, fdModelName, fdAttMainId, "2");
        }
        return null;
    }
    
    public static String setFormMappingWord(final List<Map<String, Object>> fileInfos, final List<Map<String, Object>> fillDatas, final String fdModelId, final String fdModelName, final String fdAttMainId, final String fileName) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.setFormMappingWord((List)fileInfos, (List)fillDatas, fdModelId, fdModelName, fdAttMainId, fileName, "3");
        }
        return null;
    }
    
    public static JSONObject getCovertDownload(final String fdModelId, final String fdModelName, final String type) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getCovertDownload(fdModelId, fdModelName, type);
        }
        return null;
    }
    
    public static JSONObject getCovertDownload(final String taskID) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getCovertDownload(taskID);
        }
        return null;
    }
    
    public static String getWpsDownloadUrl(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsDownloadUrl(fdMainId);
        }
        return null;
    }
    
    public static String getUpdateSysOrgPersonFdId(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getUpdateSysOrgPersonFdId(fdMainId);
        }
        return null;
    }
    
    public static Boolean checkWpsVersion(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.checkWpsVersion(fdMainId);
        }
        return null;
    }
    
    public static Boolean checkWpsPreviewIsWindows() throws Exception {
        final String isOn = WpsUtil.configInfo("thirdWpsPreviewEnabled");
        if (StringUtil.isNotNull(isOn) && "true".equals(isOn)) {
            final String thirdWpsOS = WpsUtil.configInfo("thirdWpsOS");
            if (StringUtil.isNotNull(thirdWpsOS) && "windows".equals(thirdWpsOS)) {
                return true;
            }
        }
        return false;
    }
    
    public static Boolean checkWpsPreviewIsLinux() throws Exception {
        final String isOn = WpsUtil.configInfo("thirdWpsPreviewEnabled");
        if (StringUtil.isNotNull(isOn) && "true".equals(isOn)) {
            final String thirdWpsOS = WpsUtil.configInfo("thirdWpsOS");
            if (StringUtil.isNotNull(thirdWpsOS) && "linux".equals(thirdWpsOS)) {
                return true;
            }
        }
        return false;
    }
    
    public static Boolean checkWpsCloueAutoSaveByModelName(final String modeName) throws Exception {
        Boolean flag = false;
        final Map<String, String> dataMap = BaseAppconfigCache.getCacheData("com.landray.kmss.sys.attachment.model.SysAttConfig");
        String wpsCloudAutosave = "";
        if (!dataMap.isEmpty() && dataMap.get("wpsCloudAutosave") != null) {
            wpsCloudAutosave = dataMap.get("wpsCloudAutosave");
        }
        if ("1".equals(wpsCloudAutosave)) {
            return true;
        }
        if ("0".equals(wpsCloudAutosave) && !dataMap.isEmpty() && dataMap.get("wpsCloudAutoSaveExcept") != null) {
            final String wpsCloudAutoSaveExcept = dataMap.get("wpsCloudAutoSaveExcept");
            final String[] exceptArray = wpsCloudAutoSaveExcept.split(";");
            for (int i = 0; i < exceptArray.length; ++i) {
                String model = exceptArray[i];
                if (model.startsWith("/")) {
                    model = model.substring(1, model.length());
                }
                if (StringUtil.isNotNull(model)) {
                    model = "com.landray.kmss." + model.replace("/", ".");
                    if (modeName.startsWith(model)) {
                        flag = true;
                        break;
                    }
                }
            }
        }
        return flag;
    }
    
    public static String getWpsWindowPreviewUrl(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsWindowPreviewUrl(fdMainId);
        }
        return null;
    }
    
    public static String getWpsLinuxPreviewUrl(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsLinuxPreviewUrl(fdMainId);
        }
        return null;
    }
    
    public static String getWpsOnlineDownloadUrl(final String fdMainId) throws Exception {
        final ISysAttachmentWpsCloudOfficeProvider wpsCloudOfficeProvider = (ISysAttachmentWpsCloudOfficeProvider)SpringBeanUtil.getBean("wpsCloudProvider");
        if (wpsCloudOfficeProvider != null) {
            return wpsCloudOfficeProvider.getWpsOnlineDownloadUrl(fdMainId);
        }
        return null;
    }
    
    public static Boolean getUseWpsLinuxView() throws Exception {
        final String readOlCOnfig = SysAttConfigUtil.getReadOLConfig();
        if ("2".equals(readOlCOnfig) || "3".equals(readOlCOnfig) || "4".equals(readOlCOnfig) || "5".equals(readOlCOnfig) || "6".equals(readOlCOnfig) || "7".equals(readOlCOnfig) || "8".equals(readOlCOnfig)) {
            return new Boolean(true);
        }
        return new Boolean(false);
    }
}
